# Enable debugging with Devel::MAT
%bcond_with perl_Object_Pad_enables_Devel_MAT
# Perform optional tests
%bcond_without perl_Object_Pad_enables_optional_test

Name:           perl-Object-Pad
Version:        0.35
Release:        1%{?dist}
Summary:        Simple syntax for lexical slot-based objects
License:        GPL+ or Artistic
URL:            https://metacpan.org/release/Object-Pad
Source0:        https://cpan.metacpan.org/authors/id/P/PE/PEVANS/Object-Pad-%{version}.tar.gz
BuildRequires:  coreutils
BuildRequires:  perl-devel
BuildRequires:  perl-generators
BuildRequires:  perl-interpreter
BuildRequires:  perl(Config)
%if %{with perl_Object_Pad_enables_Devel_MAT}
BuildRequires:  perl(Devel::MAT::Dumper::Helper) >= 0.41
%endif
BuildRequires:  perl(ExtUtils::CBuilder)
BuildRequires:  perl(Module::Build)
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)
BuildRequires:  perl(XS::Parse::Sublike::Builder) >= 0.10
# Run-time:
BuildRequires:  perl(:VERSION) >= 5.14
BuildRequires:  perl(Carp)
# experimental since perl 5.20
BuildRequires:  perl(experimental)
BuildRequires:  perl(feature)
# indirect not used (only with 5.20.0 <= perl < 5.31.9)
BuildRequires:  perl(mro)
# XS::Parse::Sublike is loaded from XS generated when running ./Build.PL
BuildRequires:  perl(XS::Parse::Sublike) >= 0.10
BuildRequires:  perl(XSLoader)
# Tests:
BuildRequires:  perl(attributes)
BuildRequires:  perl(base)
BuildRequires:  perl(Data::Dump)
BuildRequires:  perl(Scalar::Util)
BuildRequires:  perl(Test::Fatal)
BuildRequires:  perl(Test::More) >= 0.88
BuildRequires:  perl(Test::Refcount)
%if %{with perl_Object_Pad_enables_optional_test} && !%{defined perl_bootstrap}
# A cycle: perl-Future-AsyncAwait → perl-Object-Pad
# A cycle: perl-Syntax-Keyword-Dynamically → perl-Object-Pad
# Optional tests:
BuildRequires:  perl(Future)
BuildRequires:  perl(Future::AsyncAwait) >= 0.40
BuildRequires:  perl(Moo)
BuildRequires:  perl(Syntax::Keyword::Dynamically) >= 0.04
BuildRequires:  perl(Test::MemoryGrowth)
BuildRequires:  perl(Test::Pod) >= 1.00
%endif
Requires:       perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:       perl(experimental)
Requires:       perl(XS::Parse::Sublike) >= 0.10

%description
This Perl module provides a simple syntax for creating object classes, which
uses private variables that look like lexical variables for object member
fields.

%prep
%setup -q -n Object-Pad-%{version}
%if !%{with perl_Object_Pad_enables_optional_test} || %{defined perl_bootstrap}
for F in t/08extends-Moo.t t/80async-method.t t/80dynamically+Object-Pad.t \
    t/81async-method+dynamically.t t/90leak.t t/99pod.t; do
    rm "$F"
    perl -i -ne 'print $_ unless m{^\Q'"$F"'\E\b}' MANIFEST
done
%endif

%build
perl Build.PL --installdirs=vendor --optimize="$RPM_OPT_FLAGS"
./Build

%install
./Build install --destdir=$RPM_BUILD_ROOT --create_packlist=0
find $RPM_BUILD_ROOT -type f -name '*.bs' -size 0 -delete
%{_fixperms} $RPM_BUILD_ROOT/*

%check
./Build test

%files
%license LICENSE
%doc Changes README
%{perl_vendorarch}/auto/*
%{perl_vendorarch}/Object*
%{_mandir}/man3/*

%changelog
* Tue Jan 05 2021 Petr Pisar <ppisar@redhat.com> - 0.35-1
- 0.35 bump

* Thu Nov 05 2020 Petr Pisar <ppisar@redhat.com> - 0.34-1
- 0.34 bump

* Wed Sep 16 2020 Petr Pisar <ppisar@redhat.com> - 0.33-1
- 0.33 bump

* Tue Jul 28 2020 Petr Pisar <ppisar@redhat.com> - 0.31-2
- Finish a bootstrap

* Wed Jul 15 2020 Petr Pisar <ppisar@redhat.com> 0.31-1
- Specfile autogenerated by cpanspec 1.78.
